package com.xydl.cac.controller;

import com.xydl.cac.model.Response;
import com.xydl.cac.model.StaticVariable;
import com.xydl.cac.service.IcdFileConfigService;
import com.xydl.cac.socket.WebSocketServer;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.HashMap;
import java.util.List;

@RestController
@Api(tags = {"测试接口"})
@RequestMapping("test")
@Slf4j
public class TestController extends BasicController {

    @Resource
    IcdFileConfigService configService;
    @Resource
    WebSocketServer webSocketServer;

    @GetMapping("compare61850")
    @ApiOperation("比对61850的不同点")
    public Response<List<String>> compare61850() throws Exception {
        List<String> result = configService.compare61850();
        return Response.success(result);
    }

    @GetMapping("sendMsg")
    @ApiOperation("发送消息")
    public void sendMsg(String msg, Integer warningId) {
        webSocketServer.sendMessage(msg, warningId);
    }

    @GetMapping("realTimeClientMap")
    @ApiOperation("realTimeClientMap")
    public Response<HashMap> realTimeClientMap() {
        return Response.success(StaticVariable.realTimeClientMap);
    }

    @GetMapping("paramRelationMap")
    @ApiOperation("paramRelationMap")
    public Response<HashMap> paramRelationMap() {
        return Response.success(StaticVariable.paramRelationMap);
    }

    @GetMapping("sensorLastDataMap")
    @ApiOperation("sensorLastDataMap")
    public Response<HashMap> sensorLastDataMap() {
        return Response.success(StaticVariable.sensorLastDataMap);
    }

    @GetMapping("iecServerMap")
    @ApiOperation("iecServerMap")
    public Response<HashMap> iecServerMap() {
        return Response.success(StaticVariable.iecServerMap);
    }

    @GetMapping("rptFromActiveMap")
    @ApiOperation("rptFromActiveMap")
    public Response<HashMap> rptFromActiveMap() {
        return Response.success(StaticVariable.rptFromActiveMap);
    }

    @GetMapping("rptToActiveMap")
    @ApiOperation("rptToActiveMap")
    public Response<HashMap> rptToActiveMap() {
        return Response.success(StaticVariable.rptToActiveMap);
    }

    @GetMapping("clearMap")
    @ApiOperation("clearMap")
    public void clearMap() {
        StaticVariable.sensorLastDataMap.clear();
        StaticVariable.paramRelationMap.clear();
    }
}
